Description

encrypt_all and decrypt_all methods in lib/redmine/ciphering.rb are expected to skip validation when saving an object. But they don't

because of typo in parameter name.

It may cause a failure to run rake db:encrypt or rake db:decrypt. You can reproduce it by running the following commands.

$ bin/rake db:fixtures:load

$ bin/rake db:encrypt

rake aborted!

Some objects could not be saved after encryption, update was rolled back.

 Here is a fix:

diff --git a/lib/redmine/ciphering.rb b/lib/redmine/ciphering.rb

index d5ceb0c6c..469d3b9e6 100644

--- a/lib/redmine/ciphering.rb

+++ b/lib/redmine/ciphering.rb

@@ -74,7 +74,7 @@ module Redmine

           all.each do |object|

             clear = object.send(attribute)

             object.send "#{attribute}=", clear

-            raise(ActiveRecord::Rollback) unless object.save(:validation => false)

+            raise(ActiveRecord::Rollback) unless object.save(validate: false)

           end

         end ? true : false

       end

@@ -84,7 +84,7 @@ module Redmine

           all.each do |object|

             clear = object.send(attribute)

             object.send :write_attribute, attribute, clear

-            raise(ActiveRecord::Rollback) unless object.save(:validation => false)

+            raise(ActiveRecord::Rollback) unless object.save(validate: false)

           end

         end ? true : false

       end

Associated revisions

Revision 19999 - 2020-09-01 16:19 - Go MAEDA

Rake tasks "db:encrypt" and "db:decrypt" may fail due to validation error (#33926).

Patch by Go MAEDA.

Revision 20003 - 2020-09-02 10:46 - Go MAEDA

Merged r19999 from trunk to 4.1-stable (#33926).

Revision 20004 - 2020-09-02 10:48 - Go MAEDA

Merged r19999 from trunk to 4.0-stable (#33926).

History
#1 - 2020-08-30 10:43 - Go MAEDA

- Subject changed from Validation is not skipped due to typo when running db:encrypt/db:decrypt rake tasks to "rake db:encrypt" / "rake db:decrypt"

may fail due to validation error

#2 - 2020-08-30 15:02 - Go MAEDA

- File 33926.patch added

Added test code.

#3 - 2020-08-31 04:59 - Go MAEDA

- Target version set to 4.0.8

Setting the target version to 4.0.8.

#4 - 2020-09-01 16:19 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch.

#5 - 2020-09-01 16:20 - Go MAEDA

- Subject changed from "rake db:encrypt" / "rake db:decrypt" may fail due to validation error to Rake tasks "db:encrypt" and "db:decrypt" may fail due

to validation error

#6 - 2020-09-02 10:48 - Go MAEDA

- Status changed from Resolved to Closed

Files

33926.patch 1.86 KB 2020-08-30 Go MAEDA
